$(document).ready(function() {
	
	var baseURL=$('#contextPathHolder').attr('data-contextPath');
    
	$.ajax({
		url : baseURL + "/lista-cliente",
		async:false,
		type : "get",
		success : function(response) {
			$("#subViewDiv").html( response );
		}
	});
	
	$("#txtRuc").focusout(function(){
		var txtRuc=$("#txtRuc").val();
		if(!isEmpty(txtRuc)){
			$.ajax({
				url : baseURL + "/valida-ruc-cliente",
				data : {
					ruc: txtRuc
				},
				async:false,
				type : "get",
				contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
				dataType : 'json',
				success : function(response) {
					if(!isEmpty(response.denominacion)){
						alert(response.denominacion);
					}
				}
			});
		}
    });
	
	$("#txtDni").focusout(function(){
		var txtDni=$("#txtDni").val();
		if(!isEmpty(txtDni)){
			$.ajax({
				url : baseURL + "/valida-dni-cliente",
				data : {
					dni:txtDni
				},
				async:false,
				type : "get",
				contentType: "application/json", //this is required for spring 3 - ajax to work (at least for me)
				dataType : 'json',
				success : function(response) {
					if(!isEmpty(response.denominacion)){
						alert(response.denominacion);
					}
				}
			});
		}
    });
	
	
	$("#cmdGuardar2").click(function(){
		var selTipoPersona=$("#selTipoPersona").val();
		if(selTipoPersona==1){//Natural
			var hIdCliente=$("#hIdCliente").val();
			var idTipoDocumento=1//DNI
			var txtApellidosNombres = $("#txtApellidosNombres").val().trim().toUpperCase();
			txtApellidosNombres=normalize(txtApellidosNombres)
			
	        var txtDni = $("#txtDni").val().trim().toUpperCase();
	        var txtTelefono = $("#txtTelefono").val().trim().toUpperCase();
	        txtTelefono=normalize(txtTelefono);
	        var txtDireccion = $("#txtDireccion").val().trim().toUpperCase();
	        txtDireccion=normalize(txtDireccion);
	        
	        var txtEmail = $("#txtEmail").val().trim().toUpperCase();
	        
	        if(!isEmpty(txtApellidosNombres)){
	        	if(!isEmpty(txtDni)){
			        $.ajax({
						url : baseURL + "/registro-cliente",
						data : {
							idCliente: hIdCliente,	
							idTipoCliente:selTipoPersona,
							idTipoDocumento:idTipoDocumento,
							denominacion:txtApellidosNombres,
							nrodocumento:txtDni,
							telefono:txtTelefono,
							direccion:txtDireccion,
							email:txtEmail
						},
						async:false,
						type : "get",
						success : function(response) {
							$("#subViewDiv").html( response );
						}
					});
	        	}else{
	        		alert('El campo Dni es obligatorio!');
	        	}
	        }else{
	        	alert('El campo Apellidos Nombres es obligatorio!');
	        }
	        
		}else if(selTipoPersona==2){//Empresa
			var hIdCliente=$("#hIdCliente").val();
			var idTipoDocumento=2//RUC
			var txtRazonSocial = $("#txtRazonSocial").val().trim().toUpperCase();
			txtRazonSocial=normalize(txtRazonSocial)
	        var txtRuc = $("#txtRuc").val().trim().toUpperCase();
			var txtTelefono = $("#txtTelefono").val().trim().toUpperCase();
			txtTelefono=normalize(txtTelefono);
	        var txtDireccion = $("#txtDireccion").val().trim().toUpperCase();
	        txtDireccion=normalize(txtDireccion)
	        
	        var txtEmail = $("#txtEmail").val().trim().toUpperCase();
	        
	        if(!isEmpty(txtRazonSocial)){
	        	if(!isEmpty(txtRuc)){
			        $.ajax({
						url : baseURL + "/registro-cliente",
						data : {
							idCliente: hIdCliente,
							idTipoCliente:selTipoPersona,
							idTipoDocumento:idTipoDocumento,
							denominacion:txtRazonSocial,
							nrodocumento:txtRuc,
							telefono:txtTelefono,
							direccion:txtDireccion,
							email:txtEmail
						},
						async:false,
						type : "get",
						success : function(response) {
							$("#subViewDiv").html( response );
						}
					});
	        	}else{
	        		alert('El campo Ruc es obligatorio!');
	        	}
	        }else{
	        	alert('El campo Razon Social es obligatorio!');
	        }
		}
    });
	
	$("#cmdDelAceptar").click(function(){
		var hIdCliente=$("#hIdClienteDelete").val();
		var txtDenominacion = $("#txtDenominacionDelete").val().trim().toUpperCase();
        	
		$.ajax({
			url : baseURL + "/eliminar-cliente",
			data : {
				idCliente: hIdCliente
			},
			async:false,
			type : "get",
			success : function(response) {
				$("#subViewDiv").html( response );
			}
		});
    });
});


var normalize = (function() {
	  var from = "ÃÀÁÄÂÈÉËÊÌÍÏÎÒÓÖÔÙÚÜÛãàáäâèéëêìíïîòóöôùúüûÑñÇç", 
	      to   = "AAAAAEEEEIIIIOOOOUUUUaaaaaeeeeiiiioooouuuuNncc",
	      mapping = {};
	 
	  for(var i = 0, j = from.length; i < j; i++ )
	      mapping[ from.charAt( i ) ] = to.charAt( i );
	 
	  return function( str ) {
	      var ret = [];
	      for( var i = 0, j = str.length; i < j; i++ ) {
	          var c = str.charAt( i );
	          if( mapping.hasOwnProperty( str.charAt( i ) ) )
	              ret.push( mapping[ c ] );
	          else
	              ret.push( c );
	      }      
	      return ret.join( '' );
	  }
	 
	})();

function isEmpty(str){
  return !str.replace(/^\s+/g, '').length; // boolean (`true` if field is empty)
}
