package com.delfines.business;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.Cancelacion;
import com.delfines.vo.CancelacionDetalle;
import com.delfines.vo.Cliente;
import com.delfines.vo.Comprobante;
import com.delfines.vo.ComprobanteDetalle;
import com.delfines.vo.ComprobanteDetalleDBF;
import com.delfines.vo.Correo;
import com.delfines.vo.Guia;
import com.delfines.vo.GuiaDetalle;
import com.delfines.vo.QRComprobante;
import com.delfines.vo.TipoCambio;
import com.delfines.vo.Usuario;

public class RegistroFacturaBo {
	
	
	
	public Integer crearFacturaDesdeGuia(Integer idGuia,Usuario pUsuario){
		CallableStatement cs = null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ call dbo.crear_factura_desde_guia(?,?,?) }");
            
            cs = conn.prepareCall(query.toString());
            cs.setInt(1, idGuia);
            cs.setInt(2, pUsuario.getUsuarioId());
            cs.registerOutParameter(3, java.sql.Types.INTEGER);  
            //--
            cs.execute();
            pk=cs.getInt(3);
            System.out.println("ID_COMPROBANTE: " + pk);  
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	public Integer crearFacturaDesdeListaGuia(String idListaGuia,Usuario pUsuario){
		CallableStatement cs = null;
		Integer pk=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
        	if(idListaGuia.trim().length()>0){
        		idListaGuia=idListaGuia.substring(1, idListaGuia.trim().length());
        	}
        	
        	StringBuilder query = new StringBuilder();
            query.append("{ call dbo.crear_factura_desde_lista_guia(?,?,?) }");
            
            cs = conn.prepareCall(query.toString());
            cs.setString(1, idListaGuia);
            cs.setInt(2, pUsuario.getUsuarioId());
            cs.registerOutParameter(3, java.sql.Types.INTEGER);  
            //--
            cs.execute();
            pk=cs.getInt(3);
            System.out.println("ID_COMPROBANTE: " + pk);  
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	
	public Comprobante obtenerComprobante(Integer idComprobante){
		Comprobante obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT f.id_comprobante ");
            query.append(",f.id_tipo_comprobante ");
            query.append(",t.denominacion tipo_comprobante ");
            query.append(",f.numero_comprobante ");
            query.append(",f.id_cliente ");
            query.append(",c.denominacion denominacion_cliente ");
            query.append(",c.nro_documento nro_documento_cliente ");
            query.append(",td.tipo_doc_sunat tipo_doc_sunat ");
            query.append(",td.denominacion tipo_documento_cliente ");
            query.append(",convert(varchar(20),f.fecha_comprobante,103) fecha_comprobante ");
            query.append(",convert(varchar(10),f.fecha_comprobante,120) fecha_comprobante_txt ");
            query.append(",f.total_general ");
            query.append(",f.total_descuento ");
            query.append(",f.total_recargo ");
            query.append(",f.total_neto ");
            query.append(",(isnull(f.total_neto,0)+isnull(f.total_recargo,0)-isnull(f.total_descuento,0)) sub_total_neto ");
            query.append(",f.descripcion ");
            query.append(",coalesce(p.id_pago,p.id_pago,0) id_pago ");
            query.append(",f.estado ");
            query.append(",f.total_igv ");
            query.append(",f.seq_comprobante ");
            //--
            query.append(",f.periodo ");
            query.append(",f.mes ");
            query.append(",f.seq_mes ");
            query.append(",f.serie ");
            query.append(",dbo.CantidadConLetra(f.total_general) total_neto_word ");
            //--
            query.append(",ISNULL(c.direccion,'') direccion ");
            query.append(",ISNULL(u.username,'Cajero Lav') username ");
            query.append(",lista_guia = STUFF((SELECT ',' + cast(ii.numero_guia as varchar) "); 
    		query.append("FROM dbo.guia_comprobante i  ");
    		query.append("INNER JOIN dbo.guia ii on (i.id_guia=ii.id_guia) where i.id_comprobante=f.id_comprobante FOR XML PATH ('')), 1, 1, '') ");
            query.append("FROM dbo.comprobante f ");
            query.append("INNER JOIN dbo.cliente c ON (F.id_cliente=c.id_cliente) ");
            query.append("INNER JOIN dbo.tipo_documento td ON (c.id_tipo_documento=td.id_tipo_documento) ");
            query.append("INNER JOIN dbo.tipo_comprobante t ON (t.id_tipo_comprobante=f.id_tipo_comprobante) ");
            query.append("INNER JOIN dbo.usuario u on (u.id_usuario=f.audit_usuarioid) ");
            query.append("LEFT JOIN dbo.pago p ON (p.id_comprobante=f.id_comprobante) ");
            query.append("WHERE f.id_comprobante=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idComprobante);
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new Comprobante();
            	obj.setIdComprobante(rs.getInt("id_comprobante"));
            	obj.setIdTipoComprobante(rs.getInt("id_tipo_comprobante"));
            	obj.setTipoComprobante(rs.getString("tipo_comprobante")); 
            	obj.setNumeroComprobante(rs.getString("numero_comprobante"));
            	obj.setIdCliente(rs.getInt("id_cliente"));
            	obj.setDenominacionCliente(rs.getString("denominacion_cliente"));
            	obj.setNumeroDocumentoCliente(rs.getString("nro_documento_cliente"));
            	obj.setTipoDocumentoCliente(rs.getString("tipo_documento_cliente"));
            	obj.setFechaComprobante(rs.getString("fecha_comprobante"));
                obj.setTotalGeneral(rs.getDouble("total_general"));
                obj.setTotalDescuento(rs.getDouble("total_descuento"));
                obj.setTotalRecargo(rs.getDouble("total_recargo"));
                obj.setTotalNeto(rs.getDouble("total_neto")); 
                obj.setDescripcion(rs.getString("descripcion"));
                //--
                obj.setIdPago(rs.getInt("id_pago"));
                obj.setEstado(rs.getString("estado"));
                obj.setTotalIgv(rs.getDouble("total_igv"));
                obj.setSeqComprobante(rs.getInt("seq_comprobante"));
                //--
                obj.setSubTotalNeto(rs.getDouble("sub_total_neto"));
                obj.setDireccionCliente(rs.getString("direccion"));
                obj.setUsuario(rs.getString("username"));
                //--
                obj.setListGuia(rs.getString("lista_guia"));
                obj.setFechaComprobanteTxt(rs.getString("fecha_comprobante_txt"));
                //--
                obj.setPeriodo(rs.getInt("periodo"));
                obj.setMes(rs.getInt("mes"));
                obj.setSeqMes(rs.getInt("seq_mes"));
                obj.setSerie(rs.getString("serie"));
                //--
                obj.setTipoDocSunat(rs.getString("tipo_doc_sunat"));
                //--
                obj.setTotalNetoWord(rs.getString("total_neto_word"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public List<ComprobanteDetalle> obtenerComprobanteDetalle(Integer idComprobante){
		List<ComprobanteDetalle> lista = new ArrayList<ComprobanteDetalle>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT d.id_comprobante_detalle ");
            query.append(",d.id_servicio ");
            query.append(",s.denominacion  denominacion_servicio ");
            query.append(",d.cantidad ");
            query.append(",d.precio_unitario ");
            query.append(",d.total_linea ");
            query.append(",d.descuento ");
            query.append(",d.recargo ");
            query.append(",d.igv ");
            query.append(",d.subtotal ");
            query.append(",(isnull(d.subtotal,0)+isnull(d.recargo,0)-isnull(d.descuento,0)) sub_total_neto ");
            query.append(",d.id_guia_detalle ");
            query.append("FROM dbo.comprobante_detalle d ");
            query.append("INNER JOIN dbo.servicio s ON (d.id_servicio=s.id_servicio) ");
            query.append("WHERE d.id_comprobante=? AND d.estado=? ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idComprobante);
            ps.setInt(2, Constante.ESTADO_ACTIVO);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	ComprobanteDetalle obj=new ComprobanteDetalle();
            	obj.setIdComprobanteDetalle(rs.getInt("id_comprobante_detalle"));
            	obj.setIdServicio(rs.getInt("id_servicio"));
            	obj.setDenominacionServicio(rs.getString("denominacion_servicio"));
            	obj.setCantidad(rs.getDouble("cantidad"));
            	obj.setPrecioUnitario(rs.getDouble("precio_unitario"));
            	obj.setTotalLinea(rs.getDouble("total_linea"));
            	obj.setDescuento(rs.getDouble("descuento"));
            	obj.setRecargo(rs.getDouble("recargo"));
            	obj.setIgv(rs.getDouble("igv"));
            	obj.setSubtotal(rs.getDouble("subtotal"));
            	obj.setSubTotalNeto(rs.getDouble("sub_total_neto"));
            	obj.setIdGuiaDetalle(rs.getInt("id_guia_detalle"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<ComprobanteDetalle> obtenerComprobanteDetalleConsolidado(Integer idComprobante){
		List<ComprobanteDetalle> lista = new ArrayList<ComprobanteDetalle>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT  ");
            query.append("1 cantidad ");
            query.append(",'Servicio de Lavado y planchado' denominacion_servicio ");
            query.append(",SUM(d.total_linea) total_gravada ");
            query.append(",SUM(d.igv) total_igv ");
            query.append(",SUM(d.subtotal) total_general ");
            query.append("FROM dbo.comprobante_detalle d  ");
            query.append("INNER JOIN dbo.servicio s ON (d.id_servicio=s.id_servicio) "); 
            query.append("WHERE d.id_comprobante=? AND d.estado=? ");
            query.append("group by d.id_comprobante ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idComprobante);
            ps.setInt(2,Constante.ESTADO_ACTIVO);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	ComprobanteDetalle obj=new ComprobanteDetalle();
            	obj.setDenominacionServicio(rs.getString("denominacion_servicio"));
            	obj.setCantidad(rs.getDouble("cantidad"));
            	obj.setTotalLinea(rs.getDouble("total_general"));
            	obj.setIgv(rs.getDouble("total_igv"));
            	obj.setSubTotalNeto(rs.getDouble("total_gravada"));
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public HashMap<String, String> getNumeroComprobante(Integer idTipoComprobante){
		CallableStatement cs = null;
		
		HashMap<String,String> map=new HashMap<String, String>();
		
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ call dbo.GET_IDENT_CURRENT(?,?,?,?) }");
            
            cs = conn.prepareCall(query.toString());
            cs.setInt(1, idTipoComprobante);
            cs.registerOutParameter(2, java.sql.Types.VARCHAR);  
            cs.registerOutParameter(3, java.sql.Types.INTEGER);
            cs.registerOutParameter(4, java.sql.Types.VARCHAR);
            //--
            cs.execute();
            String numero=cs.getString(2);
            Integer secuencia=cs.getInt(3);
            String serie=cs.getString(4);
            
            map.put("numero", numero);
            map.put("secuencia", String.valueOf(secuencia));
            map.put("serie", serie);
              
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return map;
	}
	
	public Integer actualizarComprobante(Integer idTipoComprobante,String descripcion,String numeroComprobante,Integer secuencia,String serie,Integer idComprobante,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.comprobante "); 
            query.append("SET id_tipo_comprobante = ? ");
            query.append(",numero_comprobante = ? ");
            query.append(",fecha_comprobante = getdate() ");
            query.append(",descripcion = ? ");
            query.append(",estado = ? ");
            query.append(",audit_usuarioid = ? ");
            query.append(",audit_fechahora = getdate() ");
            query.append(",seq_comprobante = ? ");//SECUENCIA GOSOCKET 7077 / 489
            query.append(",serie = ? ");//SERIE GOSOCKET B013 / F013
            query.append("WHERE id_comprobante=? ");
            
            ps = conn.prepareStatement(query.toString());
        	ps.setInt(1, idTipoComprobante);
        	ps.setString(2,numeroComprobante);
        	ps.setString(3,descripcion);
        	ps.setString(4,Constante.ESTADO_INVOICE_COMPLETO);
        	ps.setInt(5, pUsuario.getUsuarioId());
        	ps.setInt(6, secuencia);
        	ps.setString(7, serie);
        	ps.setInt(8, idComprobante);
            //--
            if(ps.executeUpdate()>0){
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	public void asignarSeqMesConcar(Integer idComprobante){
		CallableStatement cs = null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ call dbo.asignar_seq_mes_CONCAR_factura(?) }");
            //SEQ_MES CONCAR
            //MES CONCAR
            //PERIODO CONCAR
            cs = conn.prepareCall(query.toString());
            cs.setInt(1, idComprobante);
            //--
            cs.execute();
              
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	
	public void calcularUSValores(String fechaComprobante){
		CallableStatement cs = null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ call dbo.calcular_us_valores(?) }");
            //
            cs = conn.prepareCall(query.toString());
            cs.setString(1, fechaComprobante);
            //--
            cs.execute();
              
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public List<Comprobante> listaComprobante(String fechaComprobante){
		Comprobante obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

		List<Comprobante> lista=new LinkedList<>();
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT f.id_comprobante ");
            query.append(",f.id_tipo_comprobante ");
            query.append(",t.denominacion tipo_comprobante ");
            query.append(",(f.serie+right('0000000' + CAST(f.seq_comprobante as varchar),6)) numero_comprobante ");
            query.append(",f.id_cliente ");
            query.append(",c.denominacion denominacion_cliente ");
            query.append(",c.nro_documento nro_documento_cliente ");
            query.append(",td.denominacion tipo_documento_cliente ");
            query.append(",convert(varchar(20),f.fecha_comprobante,103) fecha_comprobante ");
            query.append(",convert(varchar(10),f.fecha_comprobante,120) fecha_comprobante_txt ");
            query.append(",f.total_general ");
            query.append(",f.total_descuento ");
            query.append(",f.total_recargo ");
            query.append(",f.total_neto ");
            query.append(",(isnull(f.total_neto,0)+isnull(f.total_recargo,0)-isnull(f.total_descuento,0)) sub_total_neto ");
            query.append(",f.descripcion ");
            query.append(",coalesce(p.id_pago,p.id_pago,0) id_pago ");
            query.append(",f.estado ");
            query.append(",f.total_igv ");
            query.append(",f.seq_comprobante ");
            query.append(",ISNULL(c.direccion,'') direccion ");
            query.append(",ISNULL(u.username,'') username ");
            query.append(",convert(char, f.fecha_comprobante, 101) fecha_comprobante_MMDDYYYY ");
            query.append(",convert(char, f.fecha_comprobante, 12) fecha_comprobante_YYMMDD ");
            query.append(",dbo.getTimeHHmm(f.audit_fechahora) hora_comprobante_HHMM ");
            query.append(",(right('00' + CAST(f.mes as varchar),2)+right('0000' + CAST(f.seq_mes as varchar),4)) ccompro ");
            query.append("FROM dbo.comprobante f ");
            query.append("INNER JOIN dbo.cliente c ON (F.id_cliente=c.id_cliente) ");
            query.append("INNER JOIN dbo.tipo_documento td ON (c.id_tipo_documento=td.id_tipo_documento) ");
            query.append("INNER JOIN dbo.tipo_comprobante t ON (t.id_tipo_comprobante=f.id_tipo_comprobante) ");
            query.append("LEFT JOIN dbo.pago p ON (p.id_comprobante=f.id_comprobante) ");
            query.append("LEFT JOIN dbo.usuario u on (u.id_usuario=p.audit_usuarioid) ");
            query.append("WHERE convert(varchar(20),f.fecha_comprobante,103)=convert(varchar(20),?,103) and f.estado=2 ");//COMPLETADO
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1,fechaComprobante);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	obj=new Comprobante();
            	obj.setIdComprobante(rs.getInt("id_comprobante"));
            	obj.setIdTipoComprobante(rs.getInt("id_tipo_comprobante"));
            	obj.setTipoComprobante(rs.getString("tipo_comprobante")); 
            	obj.setNumeroComprobante(rs.getString("numero_comprobante"));
            	obj.setIdCliente(rs.getInt("id_cliente"));
            	obj.setDenominacionCliente(rs.getString("denominacion_cliente"));
            	obj.setNumeroDocumentoCliente(rs.getString("nro_documento_cliente"));
            	obj.setTipoDocumentoCliente(rs.getString("tipo_documento_cliente"));
            	obj.setFechaComprobante(rs.getString("fecha_comprobante"));
                obj.setTotalGeneral(rs.getDouble("total_general"));
                obj.setTotalDescuento(rs.getDouble("total_descuento"));
                obj.setTotalRecargo(rs.getDouble("total_recargo"));
                obj.setTotalNeto(rs.getDouble("total_neto")); 
                obj.setDescripcion(rs.getString("descripcion"));
                //--
                obj.setIdPago(rs.getInt("id_pago"));
                obj.setEstado(rs.getString("estado"));
                obj.setTotalIgv(rs.getDouble("total_igv"));
                obj.setSeqComprobante(rs.getInt("seq_comprobante"));
                //--
                obj.setSubTotalNeto(rs.getDouble("sub_total_neto"));
                obj.setDireccionCliente(rs.getString("direccion"));
                obj.setUsuario(rs.getString("username"));
                
                obj.setFechaComprobanteTxt(rs.getString("fecha_comprobante_txt"));
                
                obj.setFechaComprobanteDDMMYYYY(rs.getString("fecha_comprobante"));
                obj.setFechaComprobanteYYMMDD(rs.getString("fecha_comprobante_YYMMDD"));
                obj.setHoraComprobanteHHMM(rs.getString("hora_comprobante_HHMM"));
            	
                obj.setCcompro(rs.getString("ccompro"));
                obj.setFechaComprobanteMMDDYYYY(rs.getString("fecha_comprobante_MMDDYYYY"));
                lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	
	public List<Cliente> listaCliente(String fechaComprobante){
		Cliente obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

		List<Cliente> lista=new LinkedList<>();
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT c.nro_documento, ");
            query.append("c.denominacion, ");
            query.append("convert(varchar(20),f.fecha_comprobante,103) fecha_comprobante, ");
            query.append("(case when c.id_tipo_cliente=2 then 0 else 1 end) tipo_cliente ");
            query.append("FROM dbo.comprobante f  ");
            query.append("INNER JOIN dbo.cliente c ON (F.id_cliente=c.id_cliente)  ");
            query.append("WHERE convert(varchar(20),f.fecha_comprobante,103)=convert(varchar(20),?,103) and f.estado=2 ");//COMPLETADO
		
            ps = conn.prepareStatement(query.toString());
            ps.setString(1,fechaComprobante);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	obj=new Cliente();
            	obj.setNroDocumento(rs.getString("nro_documento"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setAdate(rs.getString("fecha_comprobante"));
            	obj.setAdocide(rs.getString("tipo_cliente"));
            	
                lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<ComprobanteDetalleDBF> obtenerComprobanteDetalleDBF(String fechaComprobante){
		List<ComprobanteDetalleDBF> lista = new ArrayList<ComprobanteDetalleDBF>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT c.total_general total_linea  "); 
            query.append(",c.total_igv igv   ");
            query.append(",c.total_neto subtotal   ");
            query.append(",convert(varchar(20),c.fecha_comprobante,103) fecha_comprobante    ");
            query.append(",convert(char, c.fecha_comprobante, 12) fecha_comprobante_YYMMDD  ");  
            query.append(",c.total_general_usd total_linea_usd  ");  
            query.append(",c.total_igv_usd igv_usd    ");
            query.append(",c.total_neto_usd subtotal_usd    ");
            query.append(",right('00' + CAST(c.mes as varchar),2)+right('0000' + CAST(c.seq_mes as varchar),4) ccompro  "); 
            query.append(",t.nro_documento nro_documento_cliente   ");
            query.append(",t.denominacion denominacion_cliente    ");
            query.append(",CASE WHEN c.id_tipo_comprobante=2 THEN 'BV' WHEN c.id_tipo_comprobante=1 THEN 'FT' END tipo_comprobante  ");  
            query.append(",c.serie+right('0000000' + CAST(c.seq_comprobante as varchar),7) numero_comprobante  "); 
            query.append(",convert(char, c.fecha_comprobante, 101) fecha_comprobante_MMDDYYYY  ");  
            query.append("FROM dbo.comprobante c   ");
            query.append("INNER JOIN dbo.cliente t on (t.id_cliente=c.id_cliente)  ");
            query.append("WHERE convert(varchar(20),c.fecha_comprobante,103)=convert(varchar(20),?,103) and c.estado=2 ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1,fechaComprobante);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	ComprobanteDetalleDBF obj=new ComprobanteDetalleDBF();
            	obj.setTotalLineaMN(rs.getDouble("total_linea"));
            	obj.setIgvMN(rs.getDouble("igv"));
            	obj.setSubtotalMN(rs.getDouble("subtotal"));
	            	obj.setTotalLineaUS(rs.getDouble("total_linea_usd"));
	            	obj.setIgvUS(rs.getDouble("igv_usd"));
	            	obj.setSubtotalUS(rs.getDouble("subtotal_usd"));
            	
            	obj.setFechaComprobanteDDMMYYYY(rs.getString("fecha_comprobante"));
            	obj.setFechaComprobanteYYMMDD(rs.getString("fecha_comprobante_YYMMDD"));
            	
            	obj.setCcompro(rs.getString("ccompro"));
            	obj.setNroDocumentoCliente(rs.getString("nro_documento_cliente"));
            	obj.setDenominacionCliente(rs.getString("denominacion_cliente"));
            	obj.setTipoComprobante(rs.getString("tipo_comprobante"));
            	obj.setNumeroComprobante(rs.getString("numero_comprobante"));
            	obj.setFechaComprobanteMMDDYYYY(rs.getString("fecha_comprobante_MMDDYYYY"));
            	
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	
	public TipoCambio obtenerTipoCambioVenta(String fechaCambio){
		TipoCambio obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT cambio_venta,convert(varchar,fecha_cambio,12) fecha_cambio FROM dbo.tipo_cambio WHERE convert(varchar,fecha_cambio,112)=convert(varchar,?,112) and estado=1 ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setDate(1,Util.stringToDate(fechaCambio));
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new TipoCambio();
            	obj.setTipoCambioVenta(rs.getDouble("cambio_venta"));
            	obj.setFechaCambioYYMMDD(rs.getString("fecha_cambio"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public Boolean esComprobanteCompleto(Integer idComprobante){
		Boolean result = Boolean.FALSE; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT count(1) es_completo FROM dbo.comprobante c WHERE c.id_comprobante=? and c.estado=2 ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idComprobante);
            rs = ps.executeQuery();
            
            if(rs.next()){
            	result=rs.getInt("es_completo")==1?Boolean.TRUE:Boolean.FALSE;
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
	
	
	public Integer obtenerSeqDia(String fecha){
		Integer Seq = 0; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT DATEPART(DAY,CONVERT(DATE,?,103)) SEQ ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setString(1,fecha);
            rs = ps.executeQuery();
            
            if(rs.next()){
            	Seq=rs.getInt("SEQ");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return Seq;
	}

	/**
	 * Cabecera de DBF de cancelacion.
	 */
	
	public List<Cancelacion> listaCancelacion(String fechaComprobante){
		List<Cancelacion> lista = new ArrayList<Cancelacion>(); 
		
		CallableStatement cs = null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
        	cs = conn.prepareCall("{CALL DBO.SELECT_CANCELACION_CABECERA(?)}");
        	cs.setString(1, fechaComprobante);
        	cs.execute();
            
			rs = cs.getResultSet();
            
            while(rs.next()){
            	Cancelacion obj=new Cancelacion();
            	obj.setCSUBDIA(rs.getString("CSUBDIA"));//CSUBDIA DE CANCELACION DE PAGOS
            	obj.setCCOMPRO(rs.getString("CCOMPRO"));
            	obj.setCFECCOM(rs.getString("CFECCOM"));
            	obj.setCCODMON(rs.getString("CCODMON"));//CCODMON
            	obj.setCSITUA(rs.getString("CSITUA"));//CSITUA
            	obj.setCGLOSA(rs.getString("CGLOSA"));//CGLOSA
	            obj.setCTOTAL(rs.getDouble("CTOTAL"));//header.getTotalGeneral();//CTOTAL
	            obj.setCTIPO(rs.getString("CTIPO"));//CTIPO
	            obj.setCFLAG(rs.getString("CFLAG"));//CFLAG
	            obj.setCDATE(rs.getString("CDATE"));
	            obj.setCHORA(rs.getString("CHORA"));//CHORA
	            obj.setCFECCAM(rs.getString("CFECCAM"));//CFECCAM
	            obj.setCUSER(rs.getString("CUSER"));//CUSER
	            obj.setCORIG(rs.getString("CORIG"));//CORIG
	            obj.setCFORM(rs.getString("CFORM"));//CFORM
	            obj.setCTIPCOM(rs.getString("CTIPCOM"));//CTIPCOM
	            obj.setCEXTOR(rs.getString("CEXTOR"));//CEXTOR
                lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<CancelacionDetalle> listaCancelacionDetalleFormaPago(String fechaComprobante){
		List<CancelacionDetalle> lista = new ArrayList<CancelacionDetalle>(); 
		
		CallableStatement cs = null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
        	cs = conn.prepareCall("{CALL DBO.SELECT_CANCELACION_DETALLE_FORMA_PAGO(?)}");
        	cs.setString(1, fechaComprobante);
        	cs.execute();
            
			rs = cs.getResultSet();
            
            while(rs.next()){
            	CancelacionDetalle obj=new CancelacionDetalle();
            	obj.setCSUBDIA(rs.getString("CSUBDIA"));
            	obj.setCCOMPRO(rs.getString("CCOMPRO"));
            	obj.setDSECUE(rs.getString("DSECUE"));
            	obj.setDFECCOM(rs.getString("CFECCOM"));
            	obj.setDCUENTA(rs.getString("DCUENTA"));
            	obj.setDCODANE(rs.getString("DCODANE"));
            	obj.setDCENCOS(rs.getString("DCENCOS"));
            	obj.setDCODMON(rs.getString("DCODMON"));
            	obj.setDDH(rs.getString("DDH"));
            	obj.setDIMPORT(rs.getString("DIMPORT"));
            	obj.setDTIPDOC(rs.getString("DTIPDOC"));
            	obj.setDNUMDOC(rs.getString("DNUMDOC"));
            	obj.setDFECDOC(rs.getString("DFECDOC"));
            	obj.setDFECVEN(rs.getString("DFECVEN"));
            	obj.setDAREA(rs.getString("DAREA"));
            	obj.setDFLAG(rs.getString("DFLAG")); 
            	obj.setDXGLOSA(rs.getString("DXGLOSA")); 
            	obj.setDDATE(rs.getString("DDATE"));
            	obj.setDCODANE2(rs.getString("DCODANE2"));
            	obj.setDUSIMPOR(rs.getString("DUSIMPOR"));
            	obj.setDMNIMPOR(rs.getString("DMNIMPOR"));
            	obj.setDCODARC(rs.getString("DCODARC"));
            	obj.setFLAGX(rs.getString("FLAGX"));
            	obj.setDMEDPAG(rs.getString("DMEDPAG"));
            	obj.setDIGVCOM(rs.getString("DIGVCOM"));
            	obj.setDTIDREF(rs.getString("DTIDREF"));
            	obj.setDNDOREF(rs.getString("DNDOREF"));
            	obj.setDFECREF(rs.getString("DFECREF"));
            	obj.setDBIMREF(rs.getString("DBIMREF"));
            	obj.setDIGVREF(rs.getString("DIGVREF"));
            	obj.setDMAQREF(rs.getString("DMAQREF"));
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	public List<CancelacionDetalle> listaCancelacionDetalleComprobante(String fechaComprobante){
		List<CancelacionDetalle> lista = new ArrayList<CancelacionDetalle>(); 
		
		CallableStatement cs = null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
        	cs = conn.prepareCall("{CALL DBO.SELECT_CANCELACION_DETALLE_COMPROBANTE(?)}");
        	cs.setString(1, fechaComprobante);
        	cs.execute();
            
			rs = cs.getResultSet();
            
            while(rs.next()){
            	CancelacionDetalle obj=new CancelacionDetalle();
            	obj.setCSUBDIA(rs.getString("CSUBDIA"));
            	obj.setCCOMPRO(rs.getString("CCOMPRO"));
            	obj.setDSECUE(rs.getString("DSECUE"));
            	obj.setDFECCOM(rs.getString("CFECCOM"));
            	obj.setDCUENTA(rs.getString("DCUENTA"));
            	obj.setDCODANE(rs.getString("DCODANE"));
            	obj.setDCENCOS(rs.getString("DCENCOS"));
            	obj.setDCODMON(rs.getString("DCODMON"));
            	obj.setDDH(rs.getString("DDH"));
            	obj.setDIMPORT(rs.getString("DIMPORT"));
            	obj.setDTIPDOC(rs.getString("DTIPDOC"));
            	obj.setDNUMDOC(rs.getString("DNUMDOC"));
            	obj.setDFECDOC(rs.getString("DFECDOC"));
            	obj.setDFECVEN(rs.getString("DFECVEN"));
            	obj.setDAREA(rs.getString("DAREA"));
            	obj.setDFLAG(rs.getString("DFLAG")); 
            	obj.setDXGLOSA(rs.getString("DXGLOSA")); 
            	obj.setDDATE(rs.getString("DDATE"));
            	obj.setDCODANE2(rs.getString("DCODANE2"));
            	obj.setDUSIMPOR(rs.getString("DUSIMPOR"));
            	obj.setDMNIMPOR(rs.getString("DMNIMPOR"));
            	obj.setDCODARC(rs.getString("DCODARC"));
            	obj.setFLAGX(rs.getString("FLAGX"));
            	obj.setDMEDPAG(rs.getString("DMEDPAG"));
            	obj.setDIGVCOM(rs.getString("DIGVCOM"));
            	obj.setDTIDREF(rs.getString("DTIDREF"));
            	obj.setDNDOREF(rs.getString("DNDOREF"));
            	obj.setDFECREF(rs.getString("DFECREF"));
            	obj.setDBIMREF(rs.getString("DBIMREF"));
            	obj.setDIGVREF(rs.getString("DIGVREF"));
            	obj.setDMAQREF(rs.getString("DMAQREF"));
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	
	public List<CancelacionDetalle> listaCancelacionDetalleDiferencia(String fechaComprobante){
		List<CancelacionDetalle> lista = new ArrayList<CancelacionDetalle>(); 
		
		CallableStatement cs = null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
        	cs = conn.prepareCall("{CALL DBO.SELECT_CANCELACION_DETALLE_DIFERENCIA(?)}");
        	cs.setString(1, fechaComprobante);
        	cs.execute();
            
			rs = cs.getResultSet();
            
            while(rs.next()){
            	CancelacionDetalle obj=new CancelacionDetalle();
            	obj.setCSUBDIA(rs.getString("CSUBDIA"));
            	obj.setCCOMPRO(rs.getString("CCOMPRO"));
            	obj.setDSECUE(rs.getString("DSECUE"));
            	obj.setDFECCOM(rs.getString("CFECCOM"));
            	obj.setDCUENTA(rs.getString("DCUENTA"));
            	obj.setDCODANE(rs.getString("DCODANE"));
            	obj.setDCENCOS(rs.getString("DCENCOS"));
            	obj.setDCODMON(rs.getString("DCODMON"));
            	obj.setDDH(rs.getString("DDH"));
            	obj.setDIMPORT(rs.getString("DIMPORT"));
            	obj.setDTIPDOC(rs.getString("DTIPDOC"));
            	obj.setDNUMDOC(rs.getString("DNUMDOC"));
            	obj.setDFECDOC(rs.getString("DFECDOC"));
            	obj.setDFECVEN(rs.getString("DFECVEN"));
            	obj.setDAREA(rs.getString("DAREA"));
            	obj.setDFLAG(rs.getString("DFLAG")); 
            	obj.setDXGLOSA(rs.getString("DXGLOSA")); 
            	obj.setDDATE(rs.getString("DDATE"));
            	obj.setDCODANE2(rs.getString("DCODANE2"));
            	obj.setDUSIMPOR(rs.getString("DUSIMPOR"));
            	obj.setDMNIMPOR(rs.getString("DMNIMPOR"));
            	obj.setDCODARC(rs.getString("DCODARC"));
            	obj.setFLAGX(rs.getString("FLAGX"));
            	obj.setDMEDPAG(rs.getString("DMEDPAG"));
            	obj.setDIGVCOM(rs.getString("DIGVCOM"));
            	obj.setDTIDREF(rs.getString("DTIDREF"));
            	obj.setDNDOREF(rs.getString("DNDOREF"));
            	obj.setDFECREF(rs.getString("DFECREF"));
            	obj.setDBIMREF(rs.getString("DBIMREF"));
            	obj.setDIGVREF(rs.getString("DIGVREF"));
            	obj.setDMAQREF(rs.getString("DMAQREF"));
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return lista;
	}
	
	
	public QRComprobante obtenerQRComprobante(Integer idComprobante){
		QRComprobante obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT f.id_comprobante ");
            query.append(",'20136957253' RUC ");
            query.append(",t.tipo_comprobante_sunat TIPO_DOCUMENTO ");
            query.append(",f.serie SERIE  ");
            query.append(",RIGHT('0000000' + Ltrim(Rtrim(f.seq_comprobante)),7)  NUMERO ");
            query.append(",f.total_igv MTO_TOTAL_IGV ");
            query.append(",f.total_general MTO_TOTAL_COMPROBANTE ");
            query.append(",convert(varchar(10),f.fecha_comprobante,126) FECHA_EMISION ");
            query.append(",td.tipo_doc_sunat TIPO_DOCUMENTO_ADQUIRENTE ");
            query.append(",c.nro_documento NUMERO_DOCUMENTO_ADQUIRENTE ");
            query.append(",'' VALOR_RESUMEN ");
            query.append(",datepart(year,f.fecha_comprobante) ANIO_EMISION ");
            query.append(",RIGHT('00' + Ltrim(Rtrim(datepart(month,f.fecha_comprobante))),2) MES_EMISION ");
            query.append(",RIGHT('00' + Ltrim(Rtrim(datepart(day,f.fecha_comprobante))),2) DIA_EMISION ");
            query.append(",(t.tipo_comprobante_sunat+'_'+f.serie+'_'+RIGHT('00000000' + Ltrim(Rtrim(f.seq_comprobante)),8)+'_01') XML_NAME ");
            query.append("FROM dbo.comprobante f  ");
            query.append("INNER JOIN dbo.tipo_comprobante t ON (t.id_tipo_comprobante=f.id_tipo_comprobante) "); 
            query.append("INNER JOIN dbo.cliente c ON (F.id_cliente=c.id_cliente)  ");
            query.append("INNER JOIN dbo.tipo_documento td ON (c.id_tipo_documento=td.id_tipo_documento) "); 
            query.append("WHERE f.id_comprobante=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idComprobante);
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new QRComprobante();
            	obj.setIdComprobante(rs.getInt("id_comprobante"));
            	obj.setRuc(rs.getString("RUC"));
            	obj.setTipoDocumento(rs.getString("TIPO_DOCUMENTO"));
            	obj.setSerie(rs.getString("SERIE"));
            	obj.setNumero(rs.getString("NUMERO"));
            	obj.setMontoTotalIgv(rs.getString("MTO_TOTAL_IGV"));
            	obj.setMontoTotalComprobante(rs.getString("MTO_TOTAL_COMPROBANTE"));
            	obj.setFechaEmision(rs.getString("FECHA_EMISION"));
            	obj.setTipoDocumentoAdquiriente(rs.getString("TIPO_DOCUMENTO_ADQUIRENTE"));
            	obj.setNumeroDocumentoAdquiriente(rs.getString("NUMERO_DOCUMENTO_ADQUIRENTE"));
            	
            	obj.setAnioEmision(rs.getString("ANIO_EMISION"));
            	obj.setMesEmision(rs.getString("MES_EMISION"));
            	obj.setDiaEmision(rs.getString("DIA_EMISION"));
            	
            	obj.setXmlName(rs.getString("XML_NAME"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	public Correo obtenerCorreoGuia(Integer idGuia){
		Correo obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT g.numero_guia,c.correo FROM dbo.guia g ");
            query.append("INNER JOIN dbo.cliente c ON (g.id_cliente=c.id_cliente) ");
            query.append("WHERE g.id_guia=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idGuia);
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new Correo();
            	obj.setNumero(rs.getString("numero_guia"));
            	obj.setCorreo(rs.getString("correo"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	public Correo obtenerCorreoComprobante(Integer idComprobante){
		Correo obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT g.numero_comprobante,c.correo FROM dbo.comprobante g ");
            query.append("INNER JOIN dbo.cliente c ON (g.id_cliente=c.id_cliente) ");
            query.append("WHERE g.id_comprobante=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idComprobante);
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new Correo();
            	obj.setNumero(rs.getString("numero_comprobante"));
            	obj.setCorreo(rs.getString("correo"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
}