package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.Guia;
import com.delfines.vo.GuiaDetalle;
import com.delfines.vo.ListaPrecio;
import com.delfines.vo.Usuario;

public class RegistroGuiaBo {
	
	public Integer registraGuiaDetalle(Integer idGuia,Integer idDetalleLista,Integer idServicio,Integer idPrioridad,Double precio,Double cantidad,String descripcion,
			Double totalLinea,Double descuento,Double recargo,Double totalIgv,Double totalGravada,
			Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.guia_detalle(id_guia,id_servicio,cantidad,precio_unitario,total_linea,descuento,recargo,igv,subtotal,descripcion,id_detalle_lista,estado ");
            query.append(",audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
            query.append("VALUES(?,?,?,?,?,?,?,?,?,?,?,? ");
            query.append(",?,getdate(),?,'1') ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idGuia);
            ps.setInt(2, idServicio);
            ps.setDouble(3, cantidad);
            ps.setDouble(4, precio);
            	ps.setDouble(5, totalLinea);//--TOTAL LINEA
            ps.setDouble(6, descuento);
            ps.setDouble(7, recargo);
            	ps.setDouble(8, totalIgv);//--TOTAL IGV
            	ps.setDouble(9, totalGravada);//-- TOTAL GRAVADA
            ps.setString(10, descripcion);
            ps.setInt(11, idDetalleLista);
            ps.setInt(12, Constante.ESTADO_ACTIVO);
            	ps.setInt(13, pUsuario.getUsuarioId());
            	ps.setString(14, Constante.TERMINAL);
            //--
            if(ps.executeUpdate()>0){
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);///-----
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	

	public List<GuiaDetalle> listaGuiaDetalle(Integer idGuia){
		List<GuiaDetalle> lista = new ArrayList<GuiaDetalle>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT gd.id_guia_detalle,gd.id_guia,s.id_servicio,s.denominacion,gd.cantidad,gd.precio_unitario,gd.descuento,gd.subtotal,gd.recargo,gd.total_linea,gd.descripcion,gd.id_detalle_lista,gd.igv ");
            query.append(",(gd.cantidad*gd.descuento) total_descuento, (gd.cantidad*gd.recargo) total_recargo,(gd.cantidad*gd.precio_unitario) total_bruto ");//--
            query.append("FROM dbo.guia_detalle gd ");
            query.append("INNER JOIN dbo.servicio s ON (gd.id_servicio=s.id_servicio) ");
            query.append("WHERE gd.id_guia=? and gd.estado=? ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idGuia);
            ps.setInt(2, Constante.ESTADO_ACTIVO);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	GuiaDetalle obj=new GuiaDetalle();
            	obj.setIdGuiaDetalle(rs.getInt("id_guia_detalle"));
            	obj.setIdGuia(rs.getInt("id_guia"));
            	obj.setIdServicio(rs.getInt("id_servicio"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setCantidad(rs.getDouble("cantidad"));
            	obj.setPrecioUnitario(rs.getDouble("precio_unitario"));
            	obj.setSubtotal(rs.getDouble("subtotal"));
            	obj.setDescuento(rs.getDouble("descuento"));
            	obj.setRecargo(rs.getDouble("recargo"));
            	obj.setIgv(rs.getDouble("igv"));
            	obj.setTotalLinea(rs.getDouble("total_linea"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	obj.setIdDetalleLista(rs.getInt("id_detalle_lista"));
            	//--
            	obj.setTotalDescuento(rs.getDouble("total_descuento"));
            	obj.setTotalRecargo(rs.getDouble("total_recargo"));
            	obj.setTotalBruto(rs.getDouble("total_bruto"));
            	//--
            	lista.add(obj);
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	public Integer eliminarItemGuia(Integer idGuiaDetalle,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.guia_detalle SET estado=? WHERE id_guia_detalle=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, Constante.ESTADO_ELIMINADO);
            ps.setInt(2, idGuiaDetalle);
            //--
            if(ps.executeUpdate()>0){
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	public GuiaDetalle obtenerItemGuia(Integer idGuia,Integer idGuiaDetalle){
		GuiaDetalle obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT gd.id_guia_detalle,gd.id_guia,s.id_servicio,s.denominacion,gd.cantidad,gd.precio_unitario,gd.descuento,gd.subtotal,gd.recargo,gd.total_linea,gd.descripcion,gd.id_detalle_lista,gd.igv "); 
            query.append("FROM dbo.guia_detalle gd ");
            query.append("INNER JOIN dbo.servicio s ON (gd.id_servicio=s.id_servicio) ");
            query.append("WHERE gd.id_guia=? and gd.id_guia_detalle=? ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idGuia);
            ps.setInt(2,idGuiaDetalle);	
            rs = ps.executeQuery();
            
            while(rs.next()){
            	obj=new GuiaDetalle();
            	obj.setIdGuiaDetalle(rs.getInt("id_guia_detalle"));
            	obj.setIdGuia(rs.getInt("id_guia"));
            	obj.setIdServicio(rs.getInt("id_servicio"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setCantidad(rs.getDouble("cantidad"));
            	obj.setPrecioUnitario(rs.getDouble("precio_unitario"));
            	obj.setSubtotal(rs.getDouble("subtotal"));
            	obj.setDescuento(rs.getDouble("descuento"));
            	obj.setRecargo(rs.getDouble("recargo"));
            	obj.setIgv(rs.getDouble("igv"));
            	obj.setTotalLinea(rs.getDouble("total_linea"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	obj.setIdDetalleLista(rs.getInt("id_detalle_lista"));//--
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	
	public Integer crearGuia(Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.guia(fecha_guia,estado,audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
            query.append("VALUES(getdate(),?,?,getdate(),?,'1') ");
            
            String ids[] = new String[] { "id_guia" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, Constante.ESTADO_ACTIVO);
            ps.setInt(2, pUsuario.getUsuarioId());
            ps.setString(3, Constante.TERMINAL);
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	public Guia obtenerGuia(Integer idGuia){
		Guia obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_guia,'000000' numero_guia,convert(varchar(20),fecha_guia,103) fecha_guia FROM dbo.guia WHERE id_guia=? ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idGuia);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	obj=new Guia();
            	obj.setIdGuia(rs.getInt("id_guia"));
            	obj.setNumeroGuia(rs.getString("numero_guia"));
            	obj.setFechaGuia(rs.getString("fecha_guia"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	public Guia obtenerGuiaBusqueda(Integer idGuia){
		Guia obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT g.id_guia,g.numero_guia,g.id_cliente, ");
            query.append("convert(varchar(20),g.fecha_guia,103) fecha_guia,convert(varchar(20),g.fecha_comprometida,103) fecha_comprometida,convert(varchar(20),g.fecha_entrega,103) fecha_entrega, ");
            query.append("g.id_lista_precio,g.id_prioridad, ");
            query.append("g.comentario,g.total_descuento,g.total_recargo,g.total_general,g.totalneto,(c.nro_documento+' '+c.denominacion) denominacionCliente, ");
            query.append("p.denominacion denominacionPrioridad,l.denominacion denominacionListaPrecio ");
            query.append(",f.id_comprobante ");
            query.append(",y.id_pago ");
            query.append(",c.telefono ");
            query.append(",c.direccion ");
            query.append(",g.estado ");
            query.append("FROM dbo.guia g ");
            query.append("INNER JOIN dbo.cliente c ON (g.id_cliente=c.id_cliente) ");
            query.append("INNER JOIN dbo.lista_precio l on (g.id_lista_precio=l.id_lista_precio) ");
            query.append("INNER JOIN dbo.prioridad p on (g.id_prioridad=p.id_prioridad) ");
            query.append("LEFT JOIN dbo.guia_comprobante f ON (f.id_guia=g.id_guia) ");
            query.append("LEFT JOIN dbo.pago y ON (y.id_comprobante=f.id_comprobante) ");
            query.append("WHERE g.id_guia=? ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idGuia);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	obj=new Guia();
            	obj.setIdGuia(rs.getInt("id_guia"));
            	obj.setNumeroGuia(rs.getString("numero_guia"));
            	obj.setIdCliente(rs.getInt("id_cliente"));
            	obj.setFechaGuia(rs.getString("fecha_guia"));
            	obj.setFechaComprometida(rs.getString("fecha_comprometida"));
            	obj.setFechaEntrega(rs.getString("fecha_entrega"));
            	obj.setIdListaPrecio(rs.getInt("id_lista_precio"));
            	obj.setIdPrioridad(rs.getInt("id_prioridad"));
            	obj.setComentario(rs.getString("comentario"));
            	obj.setTotalDescuento(rs.getDouble("total_descuento"));
            	obj.setTotalRecargo(rs.getDouble("total_recargo"));
            	obj.setTotalGeneral(rs.getDouble("total_general"));
            	obj.setTotalneto(rs.getDouble("totalneto"));
            	obj.setDenominacionCliente(rs.getString("denominacionCliente"));
            	obj.setDenominacionPrioridad(rs.getString("denominacionPrioridad"));
            	obj.setDenominacionListaPrecio(rs.getString("denominacionListaPrecio"));
            	//
            	obj.setIdComprobante(rs.getInt("id_comprobante"));
            	obj.setIdPago(rs.getInt("id_pago"));
            	//
            	obj.setTelefono(rs.getString("telefono"));
            	obj.setDireccion(rs.getString("direccion"));
            	//--
            	obj.setEstado(rs.getString("estado"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	
	public Guia obtenerGuiaBusquedaBySeq(Integer numero){
		Guia obj = null; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT g.id_guia,g.numero_guia,g.id_cliente, ");
            query.append("convert(varchar(20),g.fecha_guia,103) fecha_guia,convert(varchar(20),g.fecha_comprometida,103) fecha_comprometida, ");
            query.append("g.id_lista_precio,g.id_prioridad,g.id_descuento, ");
            query.append("g.comentario,g.total_descuento,g.total_recargo,g.total_general,g.totalneto,(c.nro_documento+' '+c.denominacion) denominacionCliente, ");
            query.append("p.denominacion denominacionPrioridad,l.denominacion denominacionListaPrecio ");
            query.append(",f.id_comprobante ");
            query.append(",y.id_pago ");
            query.append(",c.telefono ");
            query.append(",c.direccion ");
            query.append(",g.estado ");
            query.append(",g.comentario_entrega ");
            query.append(",g.estado_entrega ");
            query.append(",dbo.getDateTimeAMPM(g.fecha_entrega) fecha_entrega ");
            query.append(",(tc.denominacion+' con '+tp.denominacion+' '+c.nro_documento+', '+'Direccin en '+isnull(c.direccion,'--')) descripcionCliente ");
            query.append("FROM dbo.guia g ");
            query.append("INNER JOIN dbo.cliente c ON (g.id_cliente=c.id_cliente) ");
            query.append("inner join dbo.tipo_documento tp on (c.id_tipo_documento=tp.id_tipo_documento) "); 
            query.append("inner join dbo.tipo_cliente tc on (c.id_tipo_cliente=tc.id_tipo_cliente) ");
            query.append("INNER JOIN dbo.lista_precio l on (g.id_lista_precio=l.id_lista_precio) ");
            query.append("INNER JOIN dbo.prioridad p on (g.id_prioridad=p.id_prioridad) ");
            query.append("LEFT JOIN dbo.guia_comprobante f ON (f.id_guia=g.id_guia) ");
            query.append("LEFT JOIN dbo.pago y ON (y.id_comprobante=f.id_comprobante) ");
            query.append("WHERE g.seq_guia=? and g.estado=2 ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,numero);
            rs = ps.executeQuery();
            
            while(rs.next()){
            	obj=new Guia();
            	obj.setIdGuia(rs.getInt("id_guia"));
            	obj.setNumeroGuia(rs.getString("numero_guia"));
            	obj.setIdCliente(rs.getInt("id_cliente"));
            	obj.setFechaGuia(rs.getString("fecha_guia"));
            	obj.setFechaComprometida(rs.getString("fecha_comprometida"));
            	
            	obj.setIdListaPrecio(rs.getInt("id_lista_precio"));
            	obj.setIdPrioridad(rs.getInt("id_prioridad"));
            	obj.setComentario(rs.getString("comentario"));
            	obj.setTotalDescuento(rs.getDouble("total_descuento"));
            	obj.setTotalRecargo(rs.getDouble("total_recargo"));
            	obj.setTotalGeneral(rs.getDouble("total_general"));
            	obj.setTotalneto(rs.getDouble("totalneto"));
            	obj.setDenominacionCliente(rs.getString("denominacionCliente"));
            	//--
            	obj.setDescripcionCliente(rs.getString("descripcionCliente"));
            	//--
            	obj.setDenominacionPrioridad(rs.getString("denominacionPrioridad"));
            	obj.setDenominacionListaPrecio(rs.getString("denominacionListaPrecio"));
            	//
            	obj.setIdComprobante(rs.getInt("id_comprobante"));
            	obj.setIdPago(rs.getInt("id_pago"));
            	//
            	obj.setTelefono(rs.getString("telefono"));
            	obj.setDireccion(rs.getString("direccion"));
            	//--
            	obj.setEstado(rs.getString("estado"));
            	obj.setIdDescuento(rs.getInt("id_descuento"));
            	//--
            	obj.setEstadoEntrega(rs.getInt("estado_entrega"));
            	obj.setComentarioEntrega(rs.getString("comentario_entrega"));
            	obj.setFechaEntrega(rs.getString("fecha_entrega"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}
	

	public Integer actualizarGuia(Integer idGuia,Integer idCliente,String fechaComprometida,Integer idListaPrecio,Integer idPrioridad,Integer idDescuento,
			String comentario,Double totalDescuento,Double totalRecargo,Double totalGeneral,
			Double totalNeto,Double totalIgv,String numeroGuia,Integer secuencia,String serie,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.guia ");
            query.append("SET id_cliente = ? ");
            query.append(",numero_guia = ? ");
            query.append(",fecha_comprometida = ? ");
            query.append(",id_lista_precio = ? ");
            query.append(",id_prioridad = ? ");
            query.append(",id_descuento = ? ");
            query.append(",comentario = ? ");
            query.append(",total_descuento = ? ");
            query.append(",total_recargo = ? ");
            	query.append(",total_general = ? ");//TOTAL GRAVADA
            	query.append(",totalneto = ? ");//TOTAL LINEA
            query.append(",estado = ? ");
            query.append(",seq_guia = ? ");
            	query.append(",total_igv = ? ");//--TOTAL IGV
            query.append(",serie = ? ");//--TOTAL IGV
            query.append("WHERE id_guia=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1,idCliente);
            ps.setString(2,numeroGuia);
            ps.setDate(3,Util.stringToDate(fechaComprometida));
            ps.setInt(4,idListaPrecio);
            ps.setInt(5,idPrioridad);
            ps.setInt(6,idDescuento);
            ps.setString(7,comentario);
            ps.setDouble(8,totalDescuento);
            ps.setDouble(9,totalRecargo);
            	ps.setDouble(10,totalGeneral);//TOTAL GRAVADA
            	ps.setDouble(11,totalNeto);//TOTAL LINEA
            ps.setString(12,Constante.ESTADO_GUIDE_COMPLETO);
            ps.setInt(13,secuencia);
            ps.setDouble(14,totalIgv);//--TOTAL IGV
            ps.setString(15,serie);
            ps.setInt(16,idGuia);
            //--
            if(ps.executeUpdate()>0){
            	
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	
	public Integer actualizarGuiaDetalle(Integer idGuiaDetalle,Integer idGuia,Integer idDetalleLista,Integer idServicio,Integer idPrioridad,Double precio,Double cantidad,String descripcion,
			Double totalLinea,Double descuento,Double recargo,Double totalIgv,Double totalGravada,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.guia_detalle ");
            query.append("SET id_servicio=?, ");
            query.append("id_detalle_lista=?, ");
            query.append("cantidad=?, ");
            query.append("precio_unitario=?, ");
            	query.append("total_linea=?, ");//--TOTAL LINEA
            query.append("descuento=?, ");
            query.append("recargo=?, ");
            	query.append("igv=?, ");//--//--TOTAL IGV
            	query.append("subtotal=?, ");//--TOTAL GRAVADA
            query.append("descripcion=?, ");
            query.append("audit_usuarioid=?, ");
            query.append("audit_terminal=? ");
            query.append("WHERE id_guia_detalle=? AND id_guia=? ");
            
            ps = conn.prepareStatement(query.toString());
            	ps.setInt(1, idServicio);
            	ps.setInt(2, idDetalleLista);
            	ps.setDouble(3, cantidad);
            	ps.setDouble(4, precio);
            	ps.setDouble(5, totalLinea);
            	ps.setDouble(6, descuento);
            	ps.setDouble(7, recargo);
            	ps.setDouble(8, totalIgv);
            	ps.setDouble(9, totalGravada);
            	ps.setString(10, descripcion);
            	ps.setInt(11, pUsuario.getUsuarioId());
            	ps.setString(12, Constante.TERMINAL);
            ps.setInt(13, idGuiaDetalle);
            ps.setInt(14, idGuia);
            //--
            if(ps.executeUpdate()>0){
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	
	public String getDate(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT convert(varchar(20),getdate(),103) hoy ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }

            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	public Boolean esGuiaCompleto(Integer idGuia){
		Boolean result = Boolean.FALSE; 
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT count(1) es_completo FROM dbo.guia c WHERE c.id_guia=? and c.estado=2 ");
		
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idGuia);
            rs = ps.executeQuery();
            
            if(rs.next()){
            	result=rs.getInt("es_completo")==1?Boolean.TRUE:Boolean.FALSE;
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
	
	
	/**
	 *  BORRADO DE DATOS
	 *  delete FROM laver.dbo.lista_precio
		delete FROM laver.dbo.detalle_lista
		delete FROM laver.dbo.servicio
		delete FROM laver.dbo.guia_detalle
		delete FROM laver.dbo.guia
		delete FROM laver.dbo.detalle_lista
		delete FROM laver.dbo.servicio
		delete FROM laver.dbo.lista_precio
		delete FROM laver.dbo.comprobante_detalle
		delete FROM laver.dbo.pago
		delete FROM laver.dbo.comprobante
		delete FROM laver.dbo.cliente
	 */
}
