package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactory;
import com.delfines.dao.ConnectionFactorySQL;
import com.delfines.vo.EstadoEntrega;
import com.delfines.vo.Servicio;
import com.delfines.vo.TipoCambio;
import com.delfines.vo.TipoCambioDia;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

public class ServicioBatchBo {
	
	public String getDate(){
		String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT convert(varchar(20),getdate(),103) hoy ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	public Integer getDay(){
		Integer dia=0; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select DATEPART(day,getdate()) currday ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	dia=rs.getInt("currday");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return dia;
	}
	
	public Integer registraTipoCambio(String fecha,Double tipoCambioCompra,Double tipoCambioVenta,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.tipo_cambio(cambio_compra,fecha_registro,fecha_cambio,cambio_venta,estado) ");
            query.append("VALUES(?,getdate(),?,?,?) ");
            
            String ids[] = new String[] { "id_tipo_cambio" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setDouble(1, tipoCambioCompra);
            ps.setDate(2, Util.stringToDate(fecha));
            ps.setDouble(3, tipoCambioVenta);
            ps.setInt(4, Constante.ESTADO_ACTIVO);
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	public TipoCambioDia getBaseTipoCambio(){
		TipoCambioDia tipoCambio=new TipoCambioDia(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactorySQL.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT day(t.fecha_cambio) dia_cambio,t.cambio_compra,t.cambio_venta FROM dbo.tipo_cambio t WHERE convert(varchar(10),t.fecha_cambio,104)=convert(varchar(10),getdate()-1,104)");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	tipoCambio.setDia(rs.getInt("dia_cambio"));
            	tipoCambio.setCompra(rs.getDouble("cambio_compra"));
            	tipoCambio.setVenta(rs.getDouble("cambio_venta"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return tipoCambio;
	}
	
	
}
