package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.EstadoEntrega;
import com.delfines.vo.Servicio;
import com.delfines.vo.TipoCambio;
import com.delfines.vo.Usuario;
import com.delfines.vo.Value;

public class ServicioBo {
	
	public Integer guardarEstadoEntrega(Integer idGuia,String comentarioEntrega,Integer estadoEntrega){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer res=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.guia SET estado_entrega=?, comentario_entrega=?,fecha_entrega=getdate() WHERE id_guia=?");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, estadoEntrega);
            ps.setString(2, comentarioEntrega);
            ps.setInt(3, idGuia);
            //--
            res=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return res;
	}
	
	public EstadoEntrega getEstadoEntrega(Integer idGuia){
		PreparedStatement ps=null;
		ResultSet rs=null;
		
		EstadoEntrega estado=new EstadoEntrega();
		
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT isnull(estado_entrega,0) estado_entrega,isnull(comentario_entrega,'') comentario_entrega,dbo.getDateTimeAMPM(fecha_entrega) fecha_entrega FROM dbo.guia WHERE id_guia=?");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idGuia);
            //--
            rs=ps.executeQuery();
            if(rs.next()){
            	estado.setEstado(rs.getInt("estado_entrega"));
            	estado.setComentario(rs.getString("comentario_entrega"));
            	estado.setFecha(rs.getString("fecha_entrega"));
            }
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return estado;
	}
	
	
	public List<Servicio> listaServicios(){
		List<Servicio> lista = new ArrayList<Servicio>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_servicio,denominacion,descripcion,marca FROM dbo.servicio WHERE estado="+Constante.ESTADO_ACTIVO+" ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Servicio obj=new Servicio();
            	obj.setIdServicio(rs.getInt("id_servicio"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	obj.setMarca(rs.getString("marca"));
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	public Integer registraServicio(Integer idListaPrecio,String denominacion,String descripcion,Double precio,String clasificacion,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.servicio(id_lista_precio,denominacion,descripcion,marca,estado,audit_usuarioid,audit_fechahora,audit_terminal,audit_estado) ");
            query.append("VALUES(?,?,?,?,?,?,getdate(),?,1) ");
            
            String ids[] = new String[] { "id_servicio" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setInt(1, idListaPrecio);
            ps.setString(2, denominacion);
            ps.setString(3, descripcion);
            ps.setString(4, clasificacion);
            ps.setInt(5, Constante.ESTADO_ACTIVO);
            ps.setInt(6, pUsuario.getUsuarioId());
            ps.setString(7, Constante.TERMINAL);
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	
	public Integer actualizaServicio(Integer idServicio,Integer idListaPrecio,Integer idDetalleLista,String denominacion,String descripcion,Double precio,String clasificacion,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer res=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.servicio ");
            query.append("SET denominacion = ? ");
            query.append(",descripcion = ? ");
            query.append(",marca = ? ");
            query.append(",audit_usuarioid = ? ");
            query.append(",audit_fechahora = getdate() ");
            query.append(",audit_terminal = ? ");
            query.append("WHERE id_servicio=? and id_lista_precio=?");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, denominacion);
            ps.setString(2, descripcion);
            ps.setString(3, clasificacion);
            ps.setInt(4, pUsuario.getUsuarioId());
            ps.setString(5, Constante.TERMINAL);
            ps.setInt(6, idServicio);
            ps.setInt(7, idListaPrecio);
            //--
            res=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return res;
	}
	
	public Integer eliminarServicio(Integer idServicio,Integer idListaPrecio,Integer idDetalleLista,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer res=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.detalle_lista ");
            query.append("SET estado = ? ");
            query.append(",audit_usuarioid = ? ");
            query.append(",audit_fechahora = getdate() ");
            query.append(",audit_terminal = ? ");
            query.append("WHERE id_servicio=? and id_lista_precio=? and id_detalle_lista=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, Constante.ESTADO_ELIMINADO);
            ps.setInt(2, pUsuario.getUsuarioId());
            ps.setString(3, Constante.TERMINAL);
            ps.setInt(4, idServicio);
            ps.setInt(5, idListaPrecio);
            ps.setInt(6, idDetalleLista);
            //--
            res=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return res;
	}
	
	
	public List<Value> listaServiciosGuia(){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_servicio,denominacion FROM dbo.servicio WHERE estado="+Constante.ESTADO_ACTIVO+" ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id_servicio"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	

	public Servicio getServicioDetalleLista(Integer idListaPrecio,Integer idServicio){
		Servicio obj= null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT s.id_servicio,d.id_detalle_lista,s.denominacion,s.descripcion,s.marca,d.precio_unitario ");
            query.append("FROM dbo.servicio s ");
            query.append("INNER JOIN dbo.detalle_lista d ON (s.id_servicio=d.id_servicio) ");
            query.append("WHERE d.id_lista_precio=? AND d.id_servicio=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idListaPrecio);
            ps.setInt(2, idServicio);
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	obj=new Servicio();
            	obj.setIdServicio(rs.getInt("id_servicio"));
            	obj.setIdDetalleLista(rs.getInt("id_detalle_lista"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	obj.setDescripcion(rs.getString("descripcion"));
            	obj.setMarca(rs.getString("marca"));
            	//--
            	obj.setPrecioUnitario(rs.getDouble("precio_unitario"));
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return obj;
	}

	
	
	/**
	 * Tipo de cambio
	 */
	public List<TipoCambio> listaTipoCambio(){
		List<TipoCambio> lista = new ArrayList<TipoCambio>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT t.id_tipo_cambio,t.cambio_compra,convert(varchar(20),t.fecha_registro,103) fecha_registro,convert(varchar(20),t.fecha_cambio,103) fecha_cambio2,t.cambio_venta ");
            query.append("FROM dbo.tipo_cambio t WHERE t.estado="+Constante.ESTADO_ACTIVO+" ");
            query.append("ORDER BY t.fecha_cambio DESC ");
            
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	TipoCambio obj=new TipoCambio();
            	obj.setIdTipoCambio(rs.getInt("id_tipo_cambio"));
            	obj.setTipoCambioCompra(rs.getDouble("cambio_compra"));
            	obj.setTipoCambioVenta(rs.getDouble("cambio_venta"));
            	obj.setFecha(rs.getString("fecha_cambio2"));
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	public Integer registraTipoCambio(String fecha,Double tipoCambioCompra,Double tipoCambioVenta,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer pk=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.tipo_cambio(cambio_compra,fecha_registro,fecha_cambio,cambio_venta,estado) ");
            query.append("VALUES(?,getdate(),?,?,?) ");
            
            String ids[] = new String[] { "id_tipo_cambio" };
            
            ps = conn.prepareStatement(query.toString(),ids);
            ps.setDouble(1, tipoCambioCompra);
            ps.setDate(2, Util.stringToDate(fecha));
            ps.setDouble(3, tipoCambioVenta);
            ps.setInt(4, Constante.ESTADO_ACTIVO);
            //--
            if(ps.executeUpdate()>0){
            	rs = ps.getGeneratedKeys();
                if ( rs.next() ) {
                    pk = rs.getInt(1);
                }
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return pk;
	}
	
	public Integer actualizaTipoCambio(Integer idTipoCambio,Double tipoCambioCompra,Double tipoCambioVenta,String fecha,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer res=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.tipo_cambio ");
            query.append("SET cambio_compra = ? ");
            query.append(",cambio_venta = ? ");
            query.append("WHERE id_tipo_cambio=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setDouble(1, tipoCambioCompra);
            ps.setDouble(2, tipoCambioVenta);
            ps.setInt(3, idTipoCambio);
            //--
            res=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        return res;
	}
	
	public Integer eliminarTipoCambio(Integer idTipoCambio,Usuario pUsuario){
		PreparedStatement ps=null;
		ResultSet rs=null;
		Integer res=0;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("UPDATE dbo.tipo_cambio ");
            query.append("SET estado = ? ");
            query.append("WHERE id_tipo_cambio=? ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, Constante.ESTADO_ELIMINADO);
            ps.setInt(2, idTipoCambio);
            //--
            res=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return res;
	}
	
	public Integer validaTipoCambio(String fechaCambio){
		PreparedStatement ps=null;
		ResultSet rs=null;

		Integer cantidad=0;
		
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT count(1) cantidad FROM dbo.tipo_cambio WHERE convert(varchar,fecha_cambio,112)=convert(varchar,?,112) and estado=1 ");
            
            ps = conn.prepareStatement(query.toString());
            ps.setDate(1,Util.stringToDate(fechaCambio));
            rs = ps.executeQuery();
            
            if(rs.next()){
            	cantidad=rs.getInt("cantidad");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return cantidad;
	}

	public List<Value> listaServiciosGuia(Integer idListaPrecio){
		List<Value> lista = new ArrayList<Value>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT s.id_servicio,s.denominacion FROM dbo.servicio s INNER JOIN dbo.detalle_lista dl on (dl.id_servicio=s.id_servicio) WHERE s.estado=1 and dl.estado=1 and s.id_lista_precio=? ");
            ps = conn.prepareStatement(query.toString());
            ps.setInt(1, idListaPrecio);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Value obj=new Value();
            	obj.setId(rs.getInt("id_servicio"));
            	obj.setDenominacion(rs.getString("denominacion"));
            	
            	lista.add(obj);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
}
