package com.delfines.spring.controller;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.ClienteBo;
import com.delfines.business.RegistroFacturaBo;
import com.delfines.business.RegistroGuiaBo;
import com.delfines.business.RegistroPagoBo;
import com.delfines.business.ReportesBo;
import com.delfines.business.ServicioBo;
import com.delfines.business.UsuarioBo;
import com.delfines.vo.Cliente;
import com.delfines.vo.Comprobante;
import com.delfines.vo.ComprobanteDetalle;
import com.delfines.vo.ConsultaEstadoOrdenes;
import com.delfines.vo.ConsultaPagos;
import com.delfines.vo.Guia;
import com.delfines.vo.GuiaDetalle;
import com.delfines.vo.Servicio;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class ListaGuiaController {
   
	   @RequestMapping(path={"/lista-guia"},method=RequestMethod.GET)
	   public String listaGuia(Model model,HttpServletRequest request) {
		   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
		   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
			   //--
			   ClienteBo servicio=new ClienteBo();
			   
			   String fechaHoy=servicio.getDate();
			   model.addAttribute("fechaHoy", fechaHoy);
			   
			   List lListaPrecio=servicio.listaListaPrecio();
			   model.addAttribute("listaListaPrecio", lListaPrecio);
			   
			   List lListaCliente=servicio.listaListaCliente();
			   model.addAttribute("listaListaCliente", lListaCliente);
			   
			   ReportesBo bo=new ReportesBo();
			   Integer pidGrupo=bo.getIdGrupo();
			   //--
			   
			   model.addAttribute("pidGrupo", pidGrupo);
			   
			   return "lista-guia";
		   }else{
			   return "login";
		   }
	   }
	   
	   @RequestMapping(path={"/lista-guia-tabla"},method=RequestMethod.GET)
	   public String  listaGuiaTabla(Model model,HttpServletRequest request) {
		   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
		   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
			   return "lista-guia-tabla";
		   }else{
			   return "login";
		   }
	   }
	   
	@RequestMapping(path={"/lista-guia-tabla-grupo"},method=RequestMethod.GET)
	public String  listaGuiaTablaGrupo(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   if(pUsuario!=null&&pUsuario.getUsuarioId()>0){
		   return "lista-guia-tabla-grupo";
	   }else{
		   return "login";
	   }
	}
	   
	@RequestMapping(path={"/consulta-lista-guia"}, method=RequestMethod.GET)
	public ModelAndView  consultaReporteEstadoOrdenes(Integer idCliente,Integer pidGrupo,Model model,HttpServletRequest request) {
	   ReportesBo bo=new ReportesBo();
	   List<ConsultaEstadoOrdenes> lista=new ArrayList<ConsultaEstadoOrdenes>();
		   
	   lista=bo.buscarListaGuiaByFechaGuia(idCliente,pidGrupo);
	   
	   request.getSession().setAttribute("pidCliente", idCliente);//fecha de carga
	   
	   ModelAndView mv = new ModelAndView("lista-guia-tabla");
       mv.addObject("lista",lista);
       return mv;
	}

	
	@RequestMapping(path={"/add-group-guia"}, method=RequestMethod.GET)
	public ModelAndView  addGroupGuia(Integer idGuia,Integer pidGrupo,Integer idCliente,Model model,HttpServletRequest request) {
		
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
		
	   ReportesBo bo=new ReportesBo();
	   List<ConsultaEstadoOrdenes> listaGrupo=new ArrayList<ConsultaEstadoOrdenes>();
	   
	   Integer idClienteGrupo=bo.obtenerClienteGrupo(pidGrupo);
	   String msg="";
	   
	   if(idClienteGrupo.compareTo(0)==0){
		   bo.registraGrupoGuia(idGuia, pidGrupo, pUsuario);
	   }else if(idClienteGrupo.compareTo(idCliente)==0){
		   bo.registraGrupoGuia(idGuia, pidGrupo, pUsuario);   
	   }else{
		   msg="La guia seleccionada no corresponde al mismo cliente";
		   //bo.registraGrupoGuia(idGuia, pidGrupo, pUsuario);
	   }
	   
	   listaGrupo=bo.listarGuiaByGrupo(pidGrupo);
	   
	   ModelAndView mv = new ModelAndView("lista-guia-tabla-grupo");
	   mv.addObject("msg",msg);
       mv.addObject("listaGrupo",listaGrupo);
       return mv;
	}
	
	@RequestMapping(path={"/delete-group-guia"}, method=RequestMethod.GET)
	public ModelAndView  deleteGroupGuia(Integer idGuia,Integer pidGrupo,Model model,HttpServletRequest request) {
		
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
		
	   ReportesBo bo=new ReportesBo();
	   List<ConsultaEstadoOrdenes> listaGrupo=new ArrayList<ConsultaEstadoOrdenes>();
		   
	   bo.eliminaGrupoGuia(idGuia, pidGrupo, pUsuario);
	   
	   listaGrupo=bo.listarGuiaByGrupo(pidGrupo);
	   
	   ModelAndView mv = new ModelAndView("lista-guia-tabla-grupo");
       mv.addObject("listaGrupo",listaGrupo);
       return mv;
	}
	
}
