package com.delfines.spring.controller;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.OutputStream;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.ClienteBo;
import com.delfines.business.RegistroFacturaBo;
import com.delfines.business.RegistroGuiaBo;
import com.delfines.business.RegistroPagoBo;
import com.delfines.business.ReportesBo;
import com.delfines.business.ServicioBo;
import com.delfines.business.UsuarioBo;
import com.delfines.dao.ConnectionFactory;
import com.delfines.vo.Cliente;
import com.delfines.vo.Comprobante;
import com.delfines.vo.ComprobanteDetalle;
import com.delfines.vo.ConsultaDetalleOrdenes;
import com.delfines.vo.ConsultaEstadoOrdenes;
import com.delfines.vo.ConsultaPagos;
import com.delfines.vo.Guia;
import com.delfines.vo.GuiaDetalle;
import com.delfines.vo.Servicio;
import com.delfines.vo.Usuario;

import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.util.JRLoader;
import net.sf.jasperreports.export.SimpleExporterInput;
import net.sf.jasperreports.export.SimpleOutputStreamExporterOutput;

/**
 * @author imssbora
 */
@Controller
public class ReporteDetalleOrdenesController {
   
	@RequestMapping(path={"/consulta-reporte-detalle-ordenes"}, method=RequestMethod.GET)
	public ModelAndView  consultaReporteDetalleOrdenes(String fechaGuiaIni,String fechaGuiaFin,Integer idListaPrecio,Integer estadoEntrega,Integer idClasificacion,Model model,HttpServletRequest request) {
	   ReportesBo bo=new ReportesBo();
	   List<ConsultaDetalleOrdenes> lista=new ArrayList<ConsultaDetalleOrdenes>();
		   
	   if(fechaGuiaIni.trim().length()>0 && fechaGuiaFin.trim().length()>0 ){
		   lista=bo.buscarReporteDetalleOrdenesByFechaGuia(fechaGuiaIni, fechaGuiaFin,idListaPrecio,estadoEntrega,idClasificacion);
	   }
	   
	   request.getSession().setAttribute("p_fechaGuiaIni",fechaGuiaIni);
	   request.getSession().setAttribute("p_fechaGuiaFin",fechaGuiaFin);
	   
	   ModelAndView mv = new ModelAndView("reporte-detalle-ordenes-tabla");
       mv.addObject("lista",lista);
       return mv;
	}
	
	@RequestMapping(path={"/impresion-reporte-consolidado"}, method=RequestMethod.GET)
	public void  consultaReporteConsolidado(HttpServletRequest request, HttpServletResponse response) {
	    
		try {
			String fechaGuiaIni=(String)request.getSession().getAttribute("p_fechaGuiaIni");
			String fechaGuiaFin=(String)request.getSession().getAttribute("p_fechaGuiaFin");
			
        	if(fechaGuiaIni!=null&&fechaGuiaFin!=null){
        		String jasperDir = "/jasper/";
                String realPathtoJasper =  request.getServletContext().getRealPath(jasperDir);
                System.out.println(realPathtoJasper);
                
            	JasperReport reporte = (JasperReport) JRLoader.loadObject(new File(realPathtoJasper+"/cons_prod_lav.jasper"));

                Map<String, Object> parametros = new HashMap<String, Object>();
                parametros.put("P_IMAGE_PATH",realPathtoJasper+"/logo.jpg");
                
                parametros.put("P_FECHA_INICIO",fechaGuiaIni);
                parametros.put("P_FECHA_FIN",fechaGuiaFin);
                
                Connection conn = ConnectionFactory.getInstance().getConnection();
                
                JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros,conn);
                
                JRPdfExporter pdfExporter = new JRPdfExporter();
                pdfExporter.setExporterInput(new SimpleExporterInput(jasperPrint));
                ByteArrayOutputStream pdfReportStream = new ByteArrayOutputStream();
                pdfExporter.setExporterOutput(new SimpleOutputStreamExporterOutput(pdfReportStream));
                pdfExporter.exportReport();

                response.setContentType("application/pdf");
                response.setHeader("Content-Length", String.valueOf(pdfReportStream.size()));
                response.addHeader("Content-Disposition", "inline; filename=reporte_consolidado_produccion.pdf;");

                OutputStream responseOutputStream = response.getOutputStream();
                responseOutputStream.write(pdfReportStream.toByteArray());
                responseOutputStream.close();
                pdfReportStream.close();
        	}
        } catch (Exception e) {
            e.printStackTrace();
        }
		
	}
	
}
