package com.delfines.spring.controller;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.RegistroLeadsBo;
import com.delfines.vo.ErrorLead;
import com.delfines.vo.Lead;


@Controller
public class RestUploadController {

	@Autowired
    private HttpServletRequest request;
	
    @RequestMapping(path={"/theurl"},method=RequestMethod.POST)
    @ResponseBody
    public ModelAndView doUpload(@RequestParam("file") MultipartFile file,Model model,HttpServletRequest request) {                 
    	List<ErrorLead> listaErrors = new ArrayList<ErrorLead>();
        Integer errors=0;
    	if (!file.isEmpty()) {
             try {
                 String filePath = "D:\\leads\\upload\\upload_leads.csv";
                 File dest = new File(filePath);
                 file.transferTo(dest);
                 
                 errors=loadLeads(filePath);
                 //
                 RegistroLeadsBo bo=new RegistroLeadsBo();
                 if(errors>0){
                	 listaErrors=bo.listLeadsErrors();	 
                 }
             }catch(Exception e){
            	 e.printStackTrace();
             }
    	 }
    	ModelAndView mv = new ModelAndView("registro-leads-tabla");
    	if(errors>0){
    		mv.addObject("listaErrors",listaErrors);
    		mv.addObject("msgCarga",listaErrors.size()+" registros con error de carga ");
    	}else{
    		mv.addObject("listaErrors",new ArrayList<ErrorLead>());
    		mv.addObject("msgCarga"," carga de registros fue exitosa ");
    	}
   		return mv;
    }
    
    private Integer loadLeads(String filePath){
    	RegistroLeadsBo bo=new RegistroLeadsBo();
    	Integer errors=bo.loadLeads(filePath);
    	return errors;
    }

}
